import { __extends, __assign, __awaiter, __generator } from 'tslib';
import { FormArray, FormBuilder, FormControl, FormGroup } from '@angular/forms';
import { classToClass, plainToClass } from 'class-transformer';
import { getFromContainer, MetadataStorage, validate, validateSync, ValidationTypes, Validator } from 'class-validator';
import { cloneDeep, mergeWith } from 'lodash-es';
import 'reflect-metadata';
import { BehaviorSubject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template TModel
 */
var  /**
 * @template TModel
 */
DynamicFormGroup = /** @class */ (function (_super) {
    __extends(DynamicFormGroup, _super);
    function DynamicFormGroup(factoryModel, fields, defaultValidatorOptions) {
        var _this = _super.call(this, {}) || this;
        _this.factoryModel = factoryModel;
        _this.fields = fields;
        _this.defaultValidatorOptions = defaultValidatorOptions;
        _this.customValidateErrors = new BehaviorSubject({});
        _this._fb = new FormBuilder();
        /*
        const classValidators = DynamicFormGroup.getClassValidators<TModel>(
          this.factoryModel,
          this.fields,
          this.defaultValidatorOptions
        );
        const formGroup = this._fb.group(
          classValidators
        );
        Object.keys(formGroup.controls).forEach(key => {
          this.addControl(key, formGroup.controls[key]);
        });
        this.valueChanges.subscribe(data => {
          this.validate(
            undefined,
            this.defaultValidatorOptions
          );
        });*/
        _this.fields = _this.onlyFields(_this.fields);
        return _this;
    }
    Object.defineProperty(DynamicFormGroup.prototype, "externalErrors", {
        get: /**
         * @return {?}
         */
        function () {
            return this._externalErrors;
        },
        set: /**
         * @param {?} externalErrors
         * @return {?}
         */
        function (externalErrors) {
            this._externalErrors = externalErrors;
            this.validate();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DynamicFormGroup.prototype, "validatorOptions", {
        get: /**
         * @return {?}
         */
        function () {
            return this._validatorOptions;
        },
        set: /**
         * @param {?} validatorOptions
         * @return {?}
         */
        function (validatorOptions) {
            this._validatorOptions = validatorOptions;
            this.validate();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?} fields
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.getClassValidators = /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?} fields
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (factoryModel, fields, validatorOptions) {
        /** @type {?} */
        var allValidationMetadatas = getFromContainer(MetadataStorage).getTargetValidationMetadatas(factoryModel, '');
        /** @type {?} */
        var validationMetadatas = getFromContainer(MetadataStorage).getTargetValidationMetadatas(factoryModel, '', validatorOptions && validatorOptions.groups ? validatorOptions.groups : undefined);
        /** @type {?} */
        var formGroupFields = {};
        /** @type {?} */
        var validator = new Validator();
        Object.keys(fields)
            .filter(function (key) { return key.indexOf('__') !== 0; })
            .forEach(function (key) {
            /** @type {?} */
            var conditionalValidations = [];
            validationMetadatas.forEach(function (validationMetadata) {
                if (validationMetadata.propertyName === key && validationMetadata.type === 'conditionalValidation') {
                    conditionalValidations.push(validationMetadata);
                }
            });
            /** @type {?} */
            var allNestedValidations = [];
            allValidationMetadatas.forEach(function (validationMetadata) {
                if (validationMetadata.propertyName === key && validationMetadata.type === 'nestedValidation') {
                    allNestedValidations.push(validationMetadata);
                }
            });
            /** @type {?} */
            var nestedValidations = [];
            validationMetadatas.forEach(function (validationMetadata) {
                if (validationMetadata.propertyName === key && validationMetadata.type === 'nestedValidation') {
                    nestedValidations.push(validationMetadata);
                }
            });
            /** @type {?} */
            var formGroupField = formGroupFields[key];
            if (formGroupField === undefined) {
                formGroupField = Array.isArray(fields[key]) ? fields[key] : [];
            }
            validationMetadatas.forEach(function (validationMetadata) {
                if (validationMetadata.propertyName === key && validationMetadata.type !== 'conditionalValidation') {
                    var _loop_1 = function (typeKey) {
                        if (ValidationTypes.hasOwnProperty(typeKey)) {
                            if ((allNestedValidations.length === nestedValidations.length) ||
                                (fields[key] instanceof DynamicFormGroup &&
                                    (allNestedValidations.length > 0 && nestedValidations.length === 0)) ||
                                (fields[key] instanceof FormArray &&
                                    (allNestedValidations.length > 0 && nestedValidations.length === 0))) {
                                if (validationMetadata.type === ValidationTypes[typeKey] &&
                                    validator[validationMetadata.type] === undefined &&
                                    validationMetadata.type === 'nestedValidation' &&
                                    typeKey === 'NESTED_VALIDATION') {
                                    /** @type {?} */
                                    var objectToValidate_1;
                                    if (fields[key] instanceof DynamicFormGroup) {
                                        fields[key].object = fields[key].fields;
                                        objectToValidate_1 = fields[key].object;
                                    }
                                    if (formGroupField.length === 0) {
                                        formGroupField.push(fields[key]);
                                    }
                                    /** @type {?} */
                                    var nestedValidate = function (c) {
                                        /** @type {?} */
                                        var isValid = c.parent && c.parent.value ? validateSync(objectToValidate_1 || c.value, validatorOptions).length === 0 : true;
                                        return isValid
                                            ? null
                                            : {
                                                nestedValidate: {
                                                    valid: false,
                                                    type: validationMetadata.type
                                                }
                                            };
                                    };
                                    formGroupField.push(nestedValidate);
                                }
                            }
                            if (validationMetadata.type === ValidationTypes[typeKey] &&
                                validator[validationMetadata.type] === undefined &&
                                validationMetadata.type === 'customValidation' &&
                                typeKey === 'CUSTOM_VALIDATION') {
                                /** @type {?} */
                                var customValidation = function (c) {
                                    // todo: refactor
                                    /** @type {?} */
                                    var object = c.parent instanceof DynamicFormGroup
                                        ? ((/** @type {?} */ (c.parent))).object
                                        : c.parent
                                            ? c.parent.value
                                            : {};
                                    if (object) {
                                        object[key] = c.value;
                                    }
                                    /** @type {?} */
                                    var validateErrors = c.parent && c.parent.value ? validateSync(object, validatorOptions) : [];
                                    /** @type {?} */
                                    var isValid = validateErrors.filter(function (error) {
                                        if (error.children.length && error.children.filter(function (children) { return children.property === key; })) {
                                            return true;
                                        }
                                        return true;
                                    }).length === 0;
                                    return isValid
                                        ? null
                                        : {
                                            customValidation: {
                                                valid: false,
                                                type: validationMetadata.type
                                            }
                                        };
                                };
                                if (fields[key] instanceof DynamicFormGroup) {
                                    fields[key].object = fields[key].fields;
                                }
                                if (formGroupField.length === 0) {
                                    formGroupField.push(fields[key]);
                                }
                                formGroupField.push(customValidation);
                            }
                            if (validationMetadata.type === ValidationTypes[typeKey] &&
                                validator[validationMetadata.type] !== undefined) {
                                /** @type {?} */
                                var customValidate = function (c) {
                                    if (!c) {
                                        return null;
                                    }
                                    /** @type {?} */
                                    var isValid = c.parent && c.parent.value
                                        ? validator.validateValueByMetadata(c.value, validationMetadata)
                                        : true;
                                    if (!isValid && conditionalValidations.length > 0) {
                                        // todo: refactor
                                        /** @type {?} */
                                        var object = c.parent instanceof DynamicFormGroup
                                            ? ((/** @type {?} */ (c.parent))).object
                                            : c.parent
                                                ? c.parent.value
                                                : {};
                                        if (object) {
                                            object[key] = c.value;
                                        }
                                        /** @type {?} */
                                        var validateErrors = c.parent && c.parent.value ? validateSync(object, validatorOptions) : [];
                                        isValid =
                                            validateErrors.filter(function (error) {
                                                if (error.property === key) {
                                                    return true;
                                                }
                                                return false;
                                            }).length === 0;
                                    }
                                    return isValid
                                        ? null
                                        : {
                                            customValidate: {
                                                valid: false,
                                                type: validationMetadata.type
                                            }
                                        };
                                };
                                if (fields[key] instanceof DynamicFormGroup) {
                                    fields[key].object = fields[key].fields;
                                }
                                if (formGroupField.length === 0) {
                                    formGroupField.push(fields[key]);
                                }
                                formGroupField.push(customValidate);
                            }
                        }
                    };
                    for (var typeKey in ValidationTypes) {
                        _loop_1(typeKey);
                    }
                }
            });
            if (formGroupField[0] instanceof DynamicFormGroup) {
                formGroupFields[key] = formGroupField[0];
            }
            else {
                if (formGroupField[0] instanceof FormArray) {
                    formGroupFields[key] = formGroupField[0];
                }
                else {
                    formGroupFields[key] = [formGroupField[0], formGroupField.filter(function (item, index) { return index !== 0; })];
                }
            }
        });
        return formGroupFields;
    };
    /**
     * @private
     * @param {?} fields
     * @return {?}
     */
    DynamicFormGroup.prototype.onlyFields = /**
     * @private
     * @param {?} fields
     * @return {?}
     */
    function (fields) {
        var _this = this;
        /** @type {?} */
        var newFields = {};
        if (fields !== undefined) {
            Object.keys(fields).forEach(function (key) {
                if (fields[key] instanceof DynamicFormGroup) {
                    newFields[key] = _this.onlyFields(((/** @type {?} */ (fields[key]))).fields);
                }
                else {
                    if (fields[key] instanceof FormArray) {
                        if (((/** @type {?} */ (fields[key]))).controls[0] instanceof DynamicFormGroup) {
                            newFields[key] = _this.onlyFields(((/** @type {?} */ (((/** @type {?} */ (fields[key]))).controls[0]))).fields);
                        }
                        else {
                            newFields[key] = ((/** @type {?} */ (fields[key]))).controls[0].value;
                        }
                    }
                    else {
                        newFields[key] = fields[key];
                    }
                }
            });
        }
        return newFields;
    };
    Object.defineProperty(DynamicFormGroup.prototype, "object", {
        get: /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var object = this._object ? this.classToClass(this._object) : new this.factoryModel();
            if (object !== undefined) {
                Object.keys(this.controls).forEach(function (key) {
                    if (_this.controls[key] instanceof DynamicFormGroup) {
                        object[key] = ((/** @type {?} */ (_this.controls[key]))).object;
                    }
                    else {
                        if (_this.controls[key] instanceof FormArray) {
                            object[key] = [];
                            for (var i = 0; i < ((/** @type {?} */ (_this.controls[key]))).controls.length; i++) {
                                if (((/** @type {?} */ (_this.controls[key]))).controls[i] instanceof DynamicFormGroup) {
                                    object[key].push(((/** @type {?} */ (((/** @type {?} */ (_this.controls[key]))).controls[i]))).object);
                                }
                                else {
                                    object[key].push(((/** @type {?} */ (_this.controls[key]))).controls[i].value);
                                }
                            }
                        }
                        else {
                            object[key] = _this.controls[key].value;
                        }
                    }
                });
            }
            return this.plainToClass(this.factoryModel, object);
        },
        set: /**
         * @param {?} object
         * @return {?}
         */
        function (object) {
            var _this = this;
            if (object instanceof this.factoryModel) {
                this._object = this.classToClass(object);
            }
            else {
                this._object = this.plainToClass(this.factoryModel, (/** @type {?} */ (object)));
            }
            Object.keys(this.controls).forEach(function (key) {
                if (_this.controls[key] instanceof DynamicFormGroup) {
                    ((/** @type {?} */ (_this.controls[key]))).object = _this._object ? _this._object[key] : {};
                }
                else {
                    if (_this.controls[key] instanceof FormArray) {
                        /** @type {?} */
                        var objectArray = _this._object ? _this._object[key] : [];
                        /** @type {?} */
                        var formArray = ((/** @type {?} */ (_this.controls[key])));
                        /** @type {?} */
                        var isFormGroup = formArray.controls[0] instanceof DynamicFormGroup;
                        /** @type {?} */
                        var prevFormGroup = (/** @type {?} */ (formArray.controls[0]));
                        /** @type {?} */
                        var formControl = (/** @type {?} */ (formArray.controls[0]));
                        while (formArray.length !== 0) {
                            formArray.removeAt(0);
                        }
                        var _loop_2 = function (i) {
                            if (isFormGroup) {
                                /** @type {?} */
                                var dynamicFormGroup_1 = new DynamicFormGroup(prevFormGroup.factoryModel, prevFormGroup.fields, _this._validatorOptions);
                                dynamicFormGroup_1.setParent(_this);
                                /** @type {?} */
                                var classValidators = DynamicFormGroup.getClassValidators(prevFormGroup.factoryModel, prevFormGroup.fields, _this._validatorOptions);
                                /** @type {?} */
                                var formGroup_1 = _this._fb.group(classValidators);
                                Object.keys(formGroup_1.controls).forEach(function (ctrlKey) {
                                    dynamicFormGroup_1.addControl(ctrlKey, formGroup_1.controls[ctrlKey]);
                                });
                                dynamicFormGroup_1.valueChanges.subscribe(function (data) {
                                    dynamicFormGroup_1.validate(undefined, _this._validatorOptions);
                                });
                                formArray.controls.push(dynamicFormGroup_1);
                                ((/** @type {?} */ (formArray.controls[i]))).object =
                                    (_this._object && objectArray && objectArray[i]) ? objectArray[i] : {};
                            }
                            else {
                                /** @type {?} */
                                var newFormControl = new FormControl((_this._object && objectArray && objectArray[i]) ? objectArray[i] : undefined, formControl.validator);
                                newFormControl.setParent(_this);
                                formArray.controls.push(newFormControl);
                            }
                        };
                        for (var i = 0; i < objectArray.length; i++) {
                            _loop_2(i);
                        }
                    }
                    else {
                        /** @type {?} */
                        var newObject = _this._object ? _this._object[key] : [];
                        _this.controls[key].setValue(_this._object && newObject ? newObject : undefined);
                    }
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @param {?} errors
     * @return {?}
     */
    DynamicFormGroup.prototype.transformValidationErrors = /**
     * @private
     * @param {?} errors
     * @return {?}
     */
    function (errors) {
        var _this = this;
        /** @type {?} */
        var customErrors = {};
        errors.forEach(function (error) {
            if (error && error.constraints !== undefined) {
                Object.keys(error.constraints).forEach(function (key) {
                    if (!customErrors[error.property]) {
                        customErrors[error.property] = [];
                    }
                    if (((/** @type {?} */ (customErrors[error.property]))).indexOf(error.constraints[key]) === -1) {
                        ((/** @type {?} */ (customErrors[error.property]))).push(error.constraints[key]);
                    }
                });
            }
            if (error.children !== undefined && error.children.length) {
                customErrors[error.property] = _this.transformValidationErrors(error.children);
                if (Array.isArray(error.value)) {
                    customErrors[error.property] = Object.keys(customErrors[error.property]).map(function (key) { return customErrors[error.property][key]; });
                }
            }
        });
        return customErrors;
    };
    /**
     * @template TClassModel
     * @param {?} object
     * @return {?}
     */
    DynamicFormGroup.prototype.classToClass = /**
     * @template TClassModel
     * @param {?} object
     * @return {?}
     */
    function (object) {
        return classToClass(object, { ignoreDecorators: true });
    };
    /**
     * @template TClassModel, Object
     * @param {?} cls
     * @param {?} plain
     * @return {?}
     */
    DynamicFormGroup.prototype.plainToClass = /**
     * @template TClassModel, Object
     * @param {?} cls
     * @param {?} plain
     * @return {?}
     */
    function (cls, plain) {
        return plainToClass(cls, plain, { ignoreDecorators: true });
    };
    /**
     * @private
     * @param {?=} errors
     * @param {?=} externalErrors
     * @return {?}
     */
    DynamicFormGroup.prototype.mergeErrors = /**
     * @private
     * @param {?=} errors
     * @param {?=} externalErrors
     * @return {?}
     */
    function (errors, externalErrors) {
        return mergeWith(errors, externalErrors, function (objValue, srcValue) {
            if (Array.isArray(objValue) &&
                Array.isArray(srcValue) &&
                objValue.filter(function (objItem) { return srcValue.indexOf(objItem) !== -1; }).length === 0) {
                return objValue.concat(srcValue);
            }
        });
    };
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.prototype.validateAsync = /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (externalErrors, validatorOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var result, transformedErrors, allErrors, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (externalErrors === undefined) {
                            externalErrors = cloneDeep(this.externalErrors);
                        }
                        if (validatorOptions === undefined) {
                            validatorOptions = cloneDeep(this.validatorOptions);
                        }
                        if (!externalErrors) {
                            externalErrors = {};
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, validate(this.object, validatorOptions)];
                    case 2:
                        result = _a.sent();
                        transformedErrors = this.transformValidationErrors(result);
                        allErrors = this.mergeErrors(externalErrors, transformedErrors);
                        this.markAsInvalidForExternalErrors(externalErrors, this.controls);
                        this.customValidateErrors.next(allErrors);
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        throw error_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.prototype.validate = /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (externalErrors, validatorOptions) {
        this.validateAsync(externalErrors, validatorOptions).then(function () { }, function (error) { throw error; });
    };
    /**
     * @private
     * @param {?} errors
     * @param {?} controls
     * @return {?}
     */
    DynamicFormGroup.prototype.markAsInvalidForExternalErrors = /**
     * @private
     * @param {?} errors
     * @param {?} controls
     * @return {?}
     */
    function (errors, controls) {
        Object.keys(controls).forEach(function (field) {
            /** @type {?} */
            var control = controls[field];
            if (control instanceof FormControl) {
                if (errors && errors[field]) {
                    control.setErrors({ externalError: true });
                }
                else {
                    if (control.errors && control.errors.externalError === true) {
                        control.setErrors(null);
                    }
                }
            }
            else {
                if (control instanceof DynamicFormGroup) {
                    control.markAsInvalidForExternalErrors(errors && errors[field] ? ((/** @type {?} */ (errors[field]))) : {}, control.controls);
                }
                else {
                    if (control instanceof FormArray) {
                        for (var i = 0; i < ((/** @type {?} */ (control))).length; i++) {
                            if (control[i] instanceof FormControl) {
                                if (errors && errors[i] && errors[i][field]) {
                                    control[i].setErrors({ externalError: true });
                                }
                                else {
                                    if (control[i].errors && control[i].errors.externalError === true) {
                                        control[i].setErrors(null);
                                    }
                                }
                            }
                            else {
                                if (control[i] instanceof DynamicFormGroup) {
                                    control[i].markAsInvalidForExternalErrors(errors && errors[i] && errors[i][field] ? ((/** @type {?} */ (errors[i][field]))) : {}, control[i].controls);
                                }
                            }
                        }
                    }
                }
            }
        });
    };
    /**
     * @return {?}
     */
    DynamicFormGroup.prototype.validateAllFormFields = /**
     * @return {?}
     */
    function () {
        var _this = this;
        Object.keys(this.controls).forEach(function (field) {
            /** @type {?} */
            var control = _this.get(field);
            if (control instanceof FormControl) {
                control.markAsTouched({ onlySelf: true });
            }
            else {
                if (control instanceof DynamicFormGroup) {
                    control.validateAllFormFields();
                }
                else {
                    if (control instanceof FormArray) {
                        for (var i = 0; i < ((/** @type {?} */ (control))).controls.length; i++) {
                            if (((/** @type {?} */ (control))).controls[i] instanceof FormControl) {
                                ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsTouched({ onlySelf: true });
                            }
                            else {
                                if (((/** @type {?} */ (control))).controls[i] instanceof DynamicFormGroup) {
                                    ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).validateAllFormFields();
                                }
                            }
                        }
                    }
                }
            }
        });
    };
    return DynamicFormGroup;
}(FormGroup));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DynamicFormBuilder = /** @class */ (function (_super) {
    __extends(DynamicFormBuilder, _super);
    function DynamicFormBuilder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @private
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} data
     * @return {?}
     */
    DynamicFormBuilder.prototype.createEmptyObject = /**
     * @private
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} data
     * @return {?}
     */
    function (factoryModel, data) {
        var _this = this;
        if (data === void 0) { data = {}; }
        /** @type {?} */
        var object = factoryModel ? plainToClass(factoryModel, data) : data;
        /** @type {?} */
        var modifed = false;
        /** @type {?} */
        var keys = Object.keys(object);
        keys.forEach(function (key) {
            if (object[key] && object[key].length !== undefined) {
                if (object[key].length === 1 && Object.keys(object[key][0]).length > 0 && object[key][0].constructor) {
                    object[key] = [_this.createEmptyObject(object[key][0].constructor)];
                }
                if (object[key].length === 0) {
                    data[key] = [
                        {}
                    ];
                    modifed = true;
                }
            }
            else {
                data[key] = undefined;
            }
        });
        if (modifed) {
            return this.createEmptyObject(factoryModel, data);
        }
        return object;
    };
    /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} controlsConfig
     * @param {?=} extra
     * @return {?}
     */
    DynamicFormBuilder.prototype.group = /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} controlsConfig
     * @param {?=} extra
     * @return {?}
     */
    function (factoryModel, controlsConfig, extra) {
        var _this = this;
        if (controlsConfig && (controlsConfig.legacyOrOpts || controlsConfig.customValidatorOptions)) {
            return this.group(factoryModel, undefined, controlsConfig);
        }
        if (extra !== undefined && extra.customValidatorOptions === undefined) {
            extra.customValidatorOptions = { validationError: { target: false } };
        }
        /** @type {?} */
        var newControlsConfig;
        if (controlsConfig !== undefined) {
            newControlsConfig = controlsConfig;
        }
        // experimental
        if (controlsConfig === undefined) {
            newControlsConfig = __assign({}, this.createEmptyObject(factoryModel));
            Object.keys(newControlsConfig).forEach(function (key) {
                if (newControlsConfig[key] &&
                    !Array.isArray(newControlsConfig[key]) &&
                    newControlsConfig[key].constructor &&
                    typeof newControlsConfig[key] === 'object' &&
                    (newControlsConfig[key].length === undefined ||
                        (newControlsConfig[key].length !== undefined &&
                            Object.keys(newControlsConfig[key]).length === newControlsConfig[key].length))) {
                    newControlsConfig[key] = _this.group(newControlsConfig[key].constructor, extra);
                }
                else {
                    if (Array.isArray(newControlsConfig[key]) &&
                        newControlsConfig[key][0].constructor &&
                        typeof newControlsConfig[key][0] === 'object' &&
                        (newControlsConfig[key][0].length === undefined ||
                            (newControlsConfig[key][0].length !== undefined &&
                                Object.keys(newControlsConfig[key][0]).length === newControlsConfig[key][0].length))) {
                        if (newControlsConfig[key][0].constructor) {
                            newControlsConfig[key] = _super.prototype.array.call(_this, newControlsConfig[key].map(function (newControlsConfigItem) {
                                return _this.group(newControlsConfigItem.constructor, extra);
                            }));
                        }
                        else {
                            newControlsConfig[key] = _super.prototype.array.call(_this, newControlsConfig[key].map(function (newControlsConfigItem) {
                                return _this.control(newControlsConfigItem);
                            }));
                        }
                    }
                }
            });
        }
        /** @type {?} */
        var dynamicFormGroup = new DynamicFormGroup(factoryModel, newControlsConfig, extra && extra.customValidatorOptions ? extra.customValidatorOptions : undefined);
        /** @type {?} */
        var classValidators = DynamicFormGroup.getClassValidators(factoryModel, newControlsConfig, extra && extra.customValidatorOptions ? extra.customValidatorOptions : undefined);
        /** @type {?} */
        var formGroup = _super.prototype.group.call(this, classValidators, extra);
        Object.keys(formGroup.controls).forEach(function (key) {
            dynamicFormGroup.addControl(key, formGroup.controls[key]);
        });
        dynamicFormGroup.valueChanges.subscribe(function (data) {
            dynamicFormGroup.validate(undefined, extra && extra.customValidatorOptions ? extra.customValidatorOptions : undefined);
        });
        return dynamicFormGroup;
    };
    return DynamicFormBuilder;
}(FormBuilder));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DynamicFormBuilder, DynamicFormGroup };

//# sourceMappingURL=ngx-dynamic-form-builder.js.map